<!DOCTYPE html>
<html lang="en">
<head>
  <title>67.S10</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body onload=onPageLoading()>

    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <a class="navbar-brand pl-5" href="#">Frontend</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
      
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
          <ul class="navbar-nav mr-auto">
            <li class="nav-item">
              <a class="nav-link" href="order.html">Order</a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="user.html">User</a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="menu.html">Menu</a>
            </li>
            <li class="nav-item active">
              <a class="nav-link" href="drink.html">Drink</a>
            </li>
          </ul>
        </div>
      </nav>

<div class="container">
  <h2 style="text-align: center;">Quản trị Drink</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="drink-code">Mã nước uống</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-new-drink-code" name="drink-codes" placeholder="Mã nước uống..."
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="discount">Tên nước uống</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-new-drink-name" name="name" placeholder="Tên nước uống..." class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-new-message" name="note" placeholder="Note..." class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Đơn giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-new-price" name="price" placeholder="Price..." class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-12">
		  <button id="save-data" class="btn btn-info">Save Data</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã nước uống</th>
        <th>Tên nước uống</th>
        <th>Đơn giá</th>
        <th>Ghi chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
      </tr>
  </table>
  <button class="btn btn-danger" id="btn-delete-all">Delete All</button>
</div>

<!-- Update - Delete drink -->
<div>
    <div id="drink-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Update new drink</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-drink-code">Mã nước uống</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-drink-code" name="drinkcodes" placeholder="Mã nước uống..." class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-drink-name">Tên nước uống</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-drink-name" name="name" placeholder="Tên nước uống..." class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-price">Đơn giá</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-price" name="price" placeholder="Đơn giá..." class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-message">Ghi chú</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-message" name="message" placeholder="Ghi chú..." class="form-control">
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-success" id="btn-update-drink">Update drink</button>
            <button class="btn btn-danger" id="btn-delete-drink">Delete drink</button>
          </div>
        </div>
      </div>
    </div>
  </div>
<script>
    //1
    var gSTT = 0;
    const gCOL_NAME = ["id", "maNuocUong", "tenNuocUong", "donGia", "ghiChu", "ngayTao", "ngayCapNhat"]
    const gCOL_ID = 0;
    const gDRINK_CODE = 1;
    const gDRINK_NAME = 2;
    const gDON_GIA = 3;
    const gGHI_CHU = 4;
    const gNGAY_TAO = 5;
    const gNGAY_CAP_NHAT =6;


    var table = $("#user-table").DataTable({
        "columns": [
            {"data":gCOL_NAME[gCOL_ID]},
            {"data":gCOL_NAME[gDRINK_CODE]},
            {"data":gCOL_NAME[gDRINK_NAME]},
            {"data":gCOL_NAME[gDON_GIA]},
            {"data":gCOL_NAME[gGHI_CHU]},
            {"data":gCOL_NAME[gNGAY_TAO]},
            {"data":gCOL_NAME[gNGAY_CAP_NHAT]},
        ],
        columnDefs: [
            {
                targets: gCOL_ID,
                render: function (){
                    gSTT++;
                    return gSTT; 
                }
            }
        ]
    })

    var vRow;
    var vData = {
        id:"",
        maNuocUong: "",
        tenNuocUong: "",
        ghiChu: "",
        donGia: 0
    };
    
    const gBASE_URL = "http://localhost:8080/"
    //2
    $(document).ready(function(){
        $('#user-table tbody').on( 'click', 'tr', function () {
            vRow = table.row( this ).data();
            $("#drink-modal").modal("show");  
            loadDataToForm(vRow);
        });

        $("#btn-update-drink").on("click", function(){
            onBtnUpdateClick();
        })

        $("#btn-delete-drink").on("click", function(){
            onBtnDeleteClick();
        })

        $("#save-data").on("click", function(){
            onBtnSaveClick();
        })
        
        $("#btn-delete-all").on("click", function(){
            onBtnDeleteAllClick();
        })
    })
    
    //3
    function onPageLoading(){
        getAllDrink();
    }

    function onBtnSaveClick(){
        getDataFromNewInput();
        console.log(vData);
        createNewDrink(vData);
    }

    function onBtnCancelClick(){
        $("#drink-modal").modal("hide");  
    }

    function onBtnUpdateClick(){
        getDataFromFormInput();
        callApiPut(vData);
    }

    function onBtnDeleteClick(){
        show_alert("this drink");
    }

    function onBtnDeleteAllClick(){
        show_alert("all");
    }

    function show_alert(paramData) {
        if(confirm(`Do you really want to delete ${paramData}?`)){
            if(paramData == "this drink"){
                callApiDelete(vRow);
            } else {
                callApiDeleteAll();
            }
        }
    }

    //4
    function getDataFromNewInput(){
        vData.maNuocUong = $("#input-new-drink-code").val();
        vData.tenNuocUong = $("#input-new-drink-name").val();
        vData.donGia = $("#input-new-price").val();
        vData.ghiChu = $("#input-new-message").val();
    }

    function getDataFromFormInput(){
        vData.maNuocUong = $("#input-drink-code").val();
        vData.tenNuocUong = $("#input-drink-name").val();
        vData.ghiChu = $("#input-message").val();
        vData.donGia = $("#input-price").val();
        vData.id = vRow.id;
    }

    function loadDataToForm(paramData){
        $("#input-drink-code").val(paramData.maNuocUong);
        $("#input-drink-name").val(paramData.tenNuocUong);
        $("#input-message").val(paramData.ghiChu);
        $("#input-price").val(parseInt(paramData.donGia));
    }

    function loadDataToDrinkTable(paramData){
        table.clear();
		table.rows.add(paramData);
		table.draw();
    }

    function callApiDeleteAll(paramData){
        $.ajax({
            url:gBASE_URL + "drink",
            type: "DELETE",
            success: function(){
                getAllDrink();
                alert("Delete success!");
                onBtnCancelClick();
            },
            error: function(err){
                console.log(err.response);
            }
        })
    }

    function callApiDelete(paramData){
        $.ajax({
            url:gBASE_URL + "drink/" + vRow.id,
            type: "DELETE",
            success: function(){
                getAllDrink();
                alert("Delete success!");
                onBtnCancelClick();
            },
            error: function(err){
                console.log(err.response);
            }
        })
    }

    function createNewDrink(paramData){
        $.ajax({
            url: gBASE_URL + "drink",
            type: "POST",
            dataType: "json",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(paramData),
            success: function (){
                getAllDrink();
                alert("Create success!");
                $("input").val("");
            },
            error: function(err){
                console.log(err.response);
            }
        })
    }

    function callApiPut(paramData){
        $.ajax({
            url: gBASE_URL + "drink/" + vRow.id,
            type: "PUT",
            dataType: "json",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(paramData),
            success: function (){
                getAllDrink();
                alert("Update success!");
                onBtnCancelClick();
            },
            error: function(err){
                console.log(err.response);
            }
        })
    }

    function getAllDrink(){        
        $.ajax({
            url: gBASE_URL + "drink",
            type: "GET",
            dataType: "json",
            success: function(res){
                gSTT = 0;
                console.log(res);
                loadDataToDrinkTable(res);
        },
        error: function(err){
            console.log(err.response);
        }
    })
}
</script>
</body>
</html>